unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Printers;

const max = 8 ;
      dx : array[0..4] of integer = (1,1,0,-1,-1) ;
      dy : array[0..4] of integer = (0,1,1, 1, 0) ;

      dx2 : array[0..2] of integer = (-1,0,1) ;
      dy2 : array[0..2] of integer = (-1,-1,-1) ;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Button3: TButton;
    Panel1: TPanel;
    Button2: TButton;
    Edit1: TEdit;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    ListBox1: TListBox;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

  tab = array[0..max-1,0..max-1] of byte ;

var
  Form1: TForm1;
  chemin:string; {AVEC l'antislash final}

implementation

{$R *.DFM}

//*****************************************************************




procedure occuper_toutes_les_directions(var tt : tab ;xx,yy,valeur : byte) ;
var i,colonne,ligne : integer ;
begin
tt[xx,yy]:=valeur ;
for i:=0 to 4 do
    begin
    colonne:=xx ;ligne:=yy ;
    inc(colonne,dx[i]) ;inc(ligne,dy[i]) ;
    while (ligne in [0..7]) and (colonne in [0..7]) do
       begin
       tt[ligne,colonne]:=valeur ;
       inc(colonne,dx[i]) ;inc(ligne,dy[i]) ;
       end ;
    end ;
end ;


procedure jouer ;  // solution iterative
var x0,x1,x2,x3,x4,x5,x6,x7  : byte ;
    st : string[8] ;
    tab_sauve : array[0..7] of tab ;
    t : tab ;
begin
st:='       ' ;  // pour mmoriser les positions
fillchar(t[0],sizeof(t),#0) ;  // initialisation plateau
move(t,tab_sauve[0],64) ;
form1.Listbox1.items.clear ;
for x0:=0 to max-1 do
    if t[0,x0]=0 then
       begin
       occuper_toutes_les_directions(t,x0,0,2) ;
       st[1]:=chr(49+x0) ;
       move(t,tab_sauve[1],64) ;
       for x1:=0 to max-1 do
           if t[1,x1]=0 then
              begin
              occuper_toutes_les_directions(t,x1,1,2) ;
              st[2]:=chr(49+x1) ;
              move(t,tab_sauve[2],64) ;
              for x2:=0 to max-1 do
                  if t[2,x2]=0 then
                     begin
                     occuper_toutes_les_directions(t,x2,2,2) ;
                     st[3]:=chr(49+x2) ;
                     move(t,tab_sauve[3],64) ;
                     for x3:=0 to max-1 do
                         if t[3,x3]=0 then
                            begin
                            occuper_toutes_les_directions(t,x3,3,2) ;
                            st[4]:=chr(49+x3) ;
                            move(t,tab_sauve[4],64) ;
                            for x4:=0 to max-1 do
                                if t[4,x4]=0 then
                                   begin
                                   occuper_toutes_les_directions(t,x4,4,2) ;
                                   st[5]:=chr(49+x4) ;
                                   move(t,tab_sauve[5],64) ;
                                   for x5:=0 to max-1 do
                                       if t[5,x5]=0 then
                                          begin
                                          occuper_toutes_les_directions(t,x5,5,2) ;
                                          st[6]:=chr(49+x5) ;
                                          move(t,tab_sauve[6],64) ;
                                          for x6:=0 to max-1 do
                                              if t[6,x6]=0 then
                                                 begin
                                                 occuper_toutes_les_directions(t,x6,6,2) ;
                                                 st[7]:=chr(49+x6) ;
                                                 for x7:=0 to max-1 do
                                                     if t[7,x7]=0 then
                                                        form1.Listbox1.items.add(st+chr(49+x7)) ;
                                                 move(tab_sauve[6],t,64) ;
                                                 end ;
                                          move(tab_sauve[5],t,64) ;
                                          end ;
                                   move(tab_sauve[4],t,64) ;
                                   end ;
                            move(tab_sauve[3],t,64) ;
                            end ;
                     move(tab_sauve[2],t,64) ;
                     end ;
              move(tab_sauve[1],t,64) ;
              end ;
       move(tab_sauve[0],t,64) ;
       end ;
end ;

procedure jouer1(ligne : integer ;var t : tab ;st : string) ;  // recursive 1
var colonne    : byte ;
    tab_sauve  : tab ;
begin
move(t,tab_sauve,64) ;
for colonne:=0 to max-1 do
    if t[ligne,colonne]=0 then
       begin
       occuper_toutes_les_directions(t,colonne,ligne,2) ;
       if ligne<7 then
          jouer1(ligne+1,t,st+chr(49+colonne))
       else
          form1.Listbox1.items.add(st+chr(49+colonne)) ;
       move(tab_sauve,t,64) ;
       end ;
end ;

//*****************************************************************

function occupe2(x,y : integer;t : tab) : boolean ;
var i,colonne,ligne : integer ;
    sortir : boolean ;
begin
i:=-1 ;sortir:=false ;
repeat
    inc(i) ;colonne:=x ;ligne:=y ;
    dec(colonne,dx2[i]) ;dec(ligne,dy2[i]) ;
    repeat
      inc(colonne,dx2[i]) ;inc(ligne,dy2[i]) ;
      if (colonne in [0..max-1]) and (ligne>=0) then
         sortir:=(t[ligne,colonne]<>0) ;
    until (colonne=-1) or (colonne=max) or (ligne=-1) or sortir ;
until (i=2) or sortir ;  // i=0,1,2 : les trois directions
occupe2:=sortir ;
end ;

procedure jouer2(ligne : byte ;var t : tab ;st : string) ;
var x  : byte ;
begin
for x:=0 to max-1 do
    if not occupe2(x,ligne,t) then
       begin
       t[ligne,x]:=1 ;  // on pose une reine
       if ligne<max-1 then
          jouer2(ligne+1,t,st+chr(49+x))
       else
          form1.Listbox1.items.add(st+chr(49+x)) ;
       t[ligne,x]:=0 ;  // on enlve la reine
       end ;
end ;

//*****************************************************************

function test(ligne,colonne,delta : integer ;var st : string) : boolean ;
begin
if (ligne in [0,max+1]) or (colonne in [0,max+1]) then
   test:=true
else
   test:=(st[ligne]<>chr(48+colonne)) and test(ligne-1,colonne+delta,delta,st)
end ;

procedure jouer3(lg : integer;st : string) ;
var col : integer ;
begin
if lg=max+1 then
   form1.Listbox1.items.add(st)
else
   for col:=1 to max do
       if (pos(chr(col+48),st)=0) and test(lg,col,-1,st) and test(lg,col,1,st) then
          begin
          st[lg]:=chr(48+col) ;
          jouer3(lg+1,st) ;
          st[lg]:='0' ;
          end ;
end ;

//*****************************************************************
procedure TForm1.Button1Click(Sender: TObject);
var t : tab ;
begin  // cherche solution
Listbox1.Clear ;
//---- solution itrative
// jouer ;  //--- solution itrative  8 boucles

//---- solution recursive 1
//fillchar(t,sizeof(t),#0) ;
//jouer1(0,t,'') ;

//---- solution recursive 2
//fillchar(t,sizeof(t),#0) ;
//jouer2(0,t,'') ;

//---- solution recursive 3
jouer3(1,'        ') ;  // chaine de 8 espaces
end;


procedure Dessine(s:string;cnv:TCanvas;offx,offy,cote:integer);
var x,y,xreine  : integer ;  ARect:TRect;
begin
    with cnv do
          begin
          for y:=0 to 7 do
              for x:=0 to 7 do
              begin
                 brush.style:=bsSolid;
                 if odd(y) then if odd(x) then brush.color:=clWhite else brush.color:=clBlack;
                 if not odd(y) then if odd(x) then brush.color:=clBlack else brush.color:=clWhite;
                 pen.color:=clBlack;
                 rectangle(offx+x*cote,offy+y*cote,offx+x*cote+cote,offy+y*cote+cote);
                 xreine:=StrToInt(s[y+1]);
                 ARect:=Rect(offx+x*cote+2,offy+y*cote+2,offx+x*cote+cote-2,offy+y*cote+cote-2);
                 if x+1=xreine then StretchDraw(ARect,Form1.Image3.Picture.Graphic);
             end;
          end;
end ;

procedure print(s:string;cnv:TCanvas);
var cote,x,y:integer;
begin
     if cnv=Printer.Canvas then cote:=(Printer.PageWidth div 2)div 8;
     if cnv=Form1.Image1.Canvas then cote:=Form1.Image1.Width div 8;
     if cnv=Form1.Image2.Canvas then cote:=Form1.Image2.Picture.Bitmap.Width div 8;
     x:=0;
     y:=0;
     Dessine(s,cnv,x,y,cote);
end;

procedure afficher(s:string);
begin
print(s,Form1.Image1.Canvas);   // l'cran
//Si on veut imprimer
if Form1.CheckBox1.Checked then print(s,Printer.Canvas);
//Si on veut en plus un beau fichier BMP pour l'imprimeur !
if Form1.CheckBox2.Checked then print(s,Form1.Image2.Canvas);
end ;

procedure Graphique(s:string);
var ss:string;    // afficher cette solution
begin
     if length(s)<8 then
        begin
        messageDlg('Il n''y a pas 8 positions dans la bote de saisie !',mtInformation,[mbOK],0) ;
        exit ;
        end ;
     //Si on veut en plus un beau fichier BMP pour l'imprimeur !
     if Form1.CheckBox2.Checked then
            begin
            Form1.Image2.Picture.Bitmap.Width:=Printer.PageWidth;
            Form1.Image2.Picture.Bitmap.Height:=Printer.PageWidth;
            end;

     Screen.Cursor:=crHourGlass;
     Form1.Button1.Enabled:=false;
     //Si on veut imprimer
     if Form1.CheckBox1.Checked then Printer.BeginDoc;
     Afficher(s);
     //Si on veut imprimer
     if Form1.CheckBox1.Checked then Printer.EndDoc;
     Form1.Button1.Enabled:=true;
     Screen.Cursor:=crDefault;

     //Si on veut en plus un beau fichier BMP pour l'imprimeur !
     if Form1.CheckBox2.Checked then
        begin
        ss:=Chemin+'reines.bmp';
        Form1.Image2.Picture.SaveToFile(ss);
        ShowMessage('Image enregistre sous ' + ss);
        end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     Graphique(edit1.text);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     chemin:=ExtractFilePath(Application.ExeName); {le chemin de l'appli, AVEC l'antislash final}
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
close ;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
     Edit1.Text:=ListBox1.Items[ListBox1.ItemIndex];
     Graphique(ListBox1.Items[ListBox1.ItemIndex]);
end;

end.
